# AVLTreeNode | data-structure-typed
Documentation for data-structure-typed

# Class AVLTreeNode<T>

#### Type Parameters

- #### T

#### Hierarchy

- BSTNode <T>
  - AVLTreeNode

- Defined in src/data-structures/binary-tree/avl-tree.ts:8

#####
Index

### Constructors

constructor

### Properties

_count
_familyPosition
_height
_id
_left?
_parent
_right?
_val

### Accessors

count
familyPosition
height
id
left
parent
right
val

### Methods

clone
swapLocation

## Constructors

### constructor

- new AVLTreeNode<T>(id, val, count?): AVLTreeNode <T>

- #### Type Parameters

  - #### T

  #### Parameters

  - ##### id: number

  - ##### val: T

  - ##### `Optional` count: number

  #### Returns AVLTreeNode <T>

  Inherited from BSTNode.constructor

  - Defined in src/data-structures/binary-tree/binary-tree.ts:22

## Properties

### `Protected` _count

_count: number = 1

Inherited from BSTNode._count

- Defined in src/data-structures/binary-tree/binary-tree.ts:96

### `Protected` _familyPosition

_familyPosition: FamilyPosition = FamilyPosition.root

Inherited from BSTNode._familyPosition

- Defined in src/data-structures/binary-tree/binary-tree.ts:86

### `Protected` _height

_height: number = 0

Inherited from BSTNode._height

- Defined in src/data-structures/binary-tree/binary-tree.ts:106

### `Protected` _id

_id: number

Inherited from BSTNode._id

- Defined in src/data-structures/binary-tree/binary-tree.ts:28

### `Protected` `Optional` _left

_left?: null | BinaryTreeNode <T>

Inherited from BSTNode._left

- Defined in src/data-structures/binary-tree/binary-tree.ts:48

### `Protected` _parent

_parent: undefined | null | BinaryTreeNode <T>

Inherited from BSTNode._parent

- Defined in src/data-structures/binary-tree/binary-tree.ts:76

### `Protected` `Optional` _right

_right?: null | BinaryTreeNode <T>

Inherited from BSTNode._right

- Defined in src/data-structures/binary-tree/binary-tree.ts:62

### `Protected` _val

_val: T

Inherited from BSTNode._val

- Defined in src/data-structures/binary-tree/binary-tree.ts:38

## Accessors

### count

- get count(): number

- #### Returns number

  Inherited from BSTNode.count

  - Defined in src/data-structures/binary-tree/binary-tree.ts:98
- set count(v): void

- #### Parameters

  - ##### v: number

  #### Returns void

  Inherited from BSTNode.count

  - Defined in src/data-structures/binary-tree/binary-tree.ts:102

### familyPosition

- get familyPosition(): FamilyPosition

- #### Returns FamilyPosition

  Inherited from BSTNode.familyPosition

  - Defined in src/data-structures/binary-tree/binary-tree.ts:88
- set familyPosition(v): void

- #### Parameters

  - ##### v: FamilyPosition

  #### Returns void

  Inherited from BSTNode.familyPosition

  - Defined in src/data-structures/binary-tree/binary-tree.ts:92

### height

- get height(): number

- #### Returns number

  Inherited from BSTNode.height

  - Defined in src/data-structures/binary-tree/binary-tree.ts:108
- set height(v): void

- #### Parameters

  - ##### v: number

  #### Returns void

  Inherited from BSTNode.height

  - Defined in src/data-structures/binary-tree/binary-tree.ts:112

### id

- get id(): number

- #### Returns number

  Inherited from BSTNode.id

  - Defined in src/data-structures/binary-tree/binary-tree.ts:30
- set id(v): void

- #### Parameters

  - ##### v: number

  #### Returns void

  Inherited from BSTNode.id

  - Defined in src/data-structures/binary-tree/binary-tree.ts:34

### left

- get left(): undefined | null | BinaryTreeNode <T>

- #### Returns undefined | null | BinaryTreeNode <T>

  Inherited from BSTNode.left

  - Defined in src/data-structures/binary-tree/binary-tree.ts:50
- set left(v): void

- #### Parameters

  - ##### v: undefined | null | BinaryTreeNode <T>

  #### Returns void

  Inherited from BSTNode.left

  - Defined in src/data-structures/binary-tree/binary-tree.ts:54

### parent

- get parent(): undefined | null | BinaryTreeNode <T>

- #### Returns undefined | null | BinaryTreeNode <T>

  Inherited from BSTNode.parent

  - Defined in src/data-structures/binary-tree/binary-tree.ts:78
- set parent(v): void

- #### Parameters

  - ##### v: undefined | null | BinaryTreeNode <T>

  #### Returns void

  Inherited from BSTNode.parent

  - Defined in src/data-structures/binary-tree/binary-tree.ts:82

### right

- get right(): undefined | null | BinaryTreeNode <T>

- #### Returns undefined | null | BinaryTreeNode <T>

  Inherited from BSTNode.right

  - Defined in src/data-structures/binary-tree/binary-tree.ts:64
- set right(v): void

- #### Parameters

  - ##### v: undefined | null | BinaryTreeNode <T>

  #### Returns void

  Inherited from BSTNode.right

  - Defined in src/data-structures/binary-tree/binary-tree.ts:68

### val

- get val(): T

- #### Returns T

  Inherited from BSTNode.val

  - Defined in src/data-structures/binary-tree/binary-tree.ts:40
- set val(v): void

- #### Parameters

  - ##### v: T

  #### Returns void

  Inherited from BSTNode.val

  - Defined in src/data-structures/binary-tree/binary-tree.ts:44

## Methods

### clone

- clone(): AVLTreeNode <T>

- #### Returns AVLTreeNode <T>

  Overrides BSTNode.clone

  - Defined in src/data-structures/binary-tree/avl-tree.ts:9

### swapLocation

- swapLocation(swapNode): BinaryTreeNode <T>

- #### Parameters

  - ##### swapNode: BinaryTreeNode <T>

  #### Returns BinaryTreeNode <T>

  Inherited from BSTNode.swapLocation

  - Defined in src/data-structures/binary-tree/binary-tree.ts:116

Generated using TypeDoc